/**************************************************************************/
/* rxCalcNet.cmd - ᫥  ᮢ   ᪨           */
/*                                                                        */
/* ⠪:                                                             */
/*    rxCalcNet </ࠧ>                                          */
/*    rxCalcNet < ᪠>                                           */
/*    rxCalcNet <1-2>                                           */
/*                                                                        */
/* ࠬ:                                                             */
/*    /ࠧ - IP-   ᫮   ᪥               */
/*     ᪠  - IP-   ᪠                    */
/*    1-2  - 砫   IP-              */
/*                                                                        */
/* ਬ:                                                                */
/*    rxCalcNet 192.168.2.0/24                                            */
/*    rxCalcNet 192.168.2.0 255.255.255.0                                 */
/*    rxCalcNet 192.168.2.0-192.168.2.255                                 */
/*========================================================================*/
/* (c) VicTor Smirnoff, 2010                            iamvic@rambler.ru */
/*------------------------------------------------------------------------*/
trace off
numeric digits 12

mr.Version    = 'rxCalcNet v0.02'
mr.CopyLeft   = '(C)opyLeft VicTor Smirnoff, 2010'
mr.Email      = 'iamvic@rambler.ru'

rc = xGetAnsiValue()

say mr.c.Reset
say mr.b.W||mr.Version||'   '||mr.CopyLeft||'     '||mr.Email
say mr.c.Reset
/**************************************************************************/
/* 祭  ஢ઠ ࠬ஢                                        */
/**************************************************************************/
parse arg pParam

xMode = xTestParam( pParam )
if xMode = 0 then do
   say mr.b.R||'Invalid or missing parameters.'||mr.c.Reset
   rc = xHowUse()
end

mr.SubNet = ''
mr.MaskSize = 0
mr.Mask = ''
mr.StartAdr = ''
mr.FinishAdr = ''

rc = xGetParam( xMode, pParam )
if rc \= '' then do
   say mr.b.R||rc||mr.c.Reset
   rc = xHowUse()
end

say '      Subnet: '||mr.b.Y||mr.SubNet||'/'||mr.MaskSize||mr.c.Reset
say ' Subnet Mask: '||mr.b.Y||mr.Mask||mr.c.Reset
say 'Subnet Range: '||mr.b.Y||mr.StartAddr||'-'||mr.FinishAddr||mr.c.Reset

exit



/**************************************************************************/
/* xTestParam                                                             */
/*========================================================================*/
/* ᠭ: ஢ઠ ப ࠬ஢, 롮 ᯮᮡ ࠡ⪨          */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xTestParam( pParam )                                           */
/*                                                                        */
/* ࠬ:                                                             */
/*    pParam - ப ࠬ஢                                          */
/*                                                                        */
/* :                                                               */
/*    rc - ᯮᮡ ࠡ⪨                                               */
/*       = 0    ।, 訡                                       */
/*       = 1      ࠧ ᪨                              */
/*       = 2      ᪠                              */
/*       = 3    ࠭                                      */
/*------------------------------------------------------------------------*/
xTestParam: procedure
   pParam = Strip( arg( 1 ) )

   select
      when Pos( '/', pParam ) \= 0 then do
         rc = 1
      end
      when Pos( '-', pParam ) \= 0 then do
         rc = 3
      end
      when Pos( ' ', pParam ) \= 0 then do
         rc = 2
      end
      otherwise do
         rc = 0
      end
   end

   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xTestParam()                                             */
/**************************************************************************/



/**************************************************************************/
/* xGetParam                                                              */
/*========================================================================*/
/* ᠭ: 祭  ஢ઠ ࠬ஢  ப                    */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetParam( pMode, pParam )                                     */
/*                                                                        */
/* ࠬ:                                                             */
/*    pMode  - ० ࠡ⪨ ப ࠬ஢                          */
/*             = 1      ࠧ ᪨                        */
/*             = 2      ᪠                        */
/*             = 3    ࠭                                */
/*    pParam - ப ࠬ஢                                          */
/*                                                                        */
/* :                                                               */
/*    rc -  ப, ᫨  訡,                                */
/*          ᮮ饭  訡                                        */
/*------------------------------------------------------------------------*/
xGetParam: procedure expose mr.
   pMode = arg( 1 )
   pParam = Strip( arg( 2 ) )

   select
/* subnet/mask_size */
      when pMode = 1 then do
         rc = ''

         parse var pParam xSubNet '/' xMaskSize
         if (xSubNet='' | xMaskSize='') then do
            rc = 'Missing obligatory parameter.'
            return rc
         end
         if (\ xCheckIpAddr( xSubNet )) then do
            rc = 'Invalid IP-address (range of each byte: 0-255).'
            return rc
         end
         if (\ xCheckMaskSize( xMaskSize )) then do
            rc = 'Invalid subnet mask size (range: 0-32).'
            return rc
         end

         mr.Subnet = xSubnet
         mr.MaskSize = xMaskSize
         mr.Mask = xHexToDot( xGetHexMask( mr.MaskSize ) )
      end

/* subnet mask */
      when pMode = 2 then do
         rc = ''

         parse var pParam xSubNet xMask
         if (xSubNet='' | xMask='') then do
            rc = 'Missing obligatory parameter.'
            return rc
         end
         if (\ xCheckIpAddr( xSubNet )) then do
            rc = 'Invalid IP-address (range of each byte: 0-255).'
            return rc
         end
         if (\ xCheckIpAddr( xMask )) then do
            rc = 'Invalid subnet mask (range of each byte: 0-255).'
            return rc
         end

         mr.Subnet = xSubnet
         mr.Mask = xCalcMask( xMask )
         mr.MaskSize = xGetMaskSize( mr.Mask )
      end

/* start-finish */
      when pMode = 3 then do
         rc = ''

         parse var pParam xStart '-' xFinish
         if (xStart='' | xFinish='') then do
            rc = 'Missing obligatory parameter.'
            return rc
         end
         if (\ xCheckIpAddr( xStart )) | ,
            (\ xCheckIpAddr( xFinish )) then do
            rc = 'Invalid IP-address (range of each byte: 0-255).'
            return rc
         end

         x0011 = BitXOR( x2b(xDotToHex( xStart )), x2b(xDotToHex( xFinish )) )
         x1100 = BitXOR( x2b('FFFFFFFF'), x0011 )
         xPos = Pos( '0', x1100 )
         if xPos = 0 then do
            mr.MaskSize = 32
         end
         else do
            mr.MaskSize = xPos - 1
         end
         mr.Mask = xHexToDot( xGetHexMask( mr.MaskSize ) )

         xHexStart = xDotToHex( xStart )
         xHexFinish = xDotToHex( xFinish )
         if xHexStart > xHexFinish then do
            mr.SubNet = xFinish
         end
         else do
            mr.SubNet = xStart
         end
      end

/* unkown mode */
      otherwise do
         rc = 'Unknown parameter processing mode.'
         return rc
      end
   end

   xHexAddr = xDotToHex( mr.SubNet )
   xHexMask = xDotToHex( mr.Mask )
   xHexSubNet = b2x( BitAND( x2b(xHexAddr), x2b(xHexMask) ) )
   mr.SubNet = xHexToDot( xHexSubNet )
   mr.StartAddr = mr.SubNet
   xHexSubNetRange = b2x( BitOR( x2b(xHexSubNet), BitXOR( x2b('FFFFFFFF'), x2b(xHexMask) ) ) )
   mr.FinishAddr = xHexToDot( xHexSubNetRange )
   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetParam()                                              */
/**************************************************************************/



/**************************************************************************/
/* xDotToHex()                                                            */
/*========================================================================*/
/* ᠭ: ८ࠧ   dot-樨  hex-             */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xDotToHex( pDotAddr )                                          */
/*                                                                        */
/* ࠬ:                                                             */
/*    pDotAddr -   筮 樨 (dot-)                 */
/*                                                                        */
/* :                                                               */
/*    rc -   ⭠筮 ଥ                                */
/*------------------------------------------------------------------------*/
xDotToHex: procedure
   pDotAddr = arg( 1 )

   parse var pDotAddr x.3'.'x.2'.'x.1'.'x.0
   rc = d2x( x.3, 2 )||d2x( x.2, 2 )||d2x( x.1, 2 )||d2x( x.0, 2 )
   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xDotToHex()                                              */
/**************************************************************************/



/**************************************************************************/
/* xHexToDot()                                                            */
/*========================================================================*/
/* ᠭ: ८ࠧ   hex-  dot-             */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xHexToDot( pHexAddr )                                          */
/*                                                                        */
/* ࠬ:                                                             */
/*    pHexAddr -   ⭠筮 ଥ                          */
/*                                                                        */
/* :                                                               */
/*    rc -   筮 樨 (dot-)                       */
/*------------------------------------------------------------------------*/
xHexToDot: procedure
   pHexAddr = arg( 1 )

   do i = 0 to 3
      x.i = substr( pHexAddr, 7-i*2, 2 )
   end
   rc = x2d( x.3, 4 )||'.'||x2d( x.2, 4 )||'.'||x2d( x.1, 4 )||'.'||x2d( x.0, 4 )
   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xHexToDot()                                              */
/**************************************************************************/



/**************************************************************************/
/* xCheckIpAddr()                                                         */
/*========================================================================*/
/* ᠭ: ஢ઠ ࠢ쭮                                  */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xCheckIpAddr( pAddr )                                          */
/*                                                                        */
/* ࠬ:                                                             */
/*    xAddr - IP-                                                    */
/*                                                                        */
/* :                                                               */
/*    rc = 0 -  ࠢ                                         */
/*       = 1 -  ࠢ                                           */
/*------------------------------------------------------------------------*/
xCheckIpAddr: procedure
   pAddr = arg(1)

   x.0 = 4
   parse var pAddr x.4'.'x.3'.'x.2'.'x.1 .
   do i=1 to x.0
      if (\ xCheckIpAddrByte( x.i )) then do
         return 0
      end
   end
   return 1
/*------------------------------------------------------------------------*/
/*  㭪樨 xCheckIpAddr()                                           */
/**************************************************************************/



/**************************************************************************/
/* xCheckIpAddrByte()                                                     */
/*========================================================================*/
/* ᠭ: ஢ઠ ࠢ쭮 ⮢                           */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xCheckIpAddrByte( pByte )                                      */
/*                                                                        */
/* ࠬ:                                                             */
/*    pByte -  IP-                                              */
/*                                                                        */
/* :                                                               */
/*    rc = 0 -  ࠢ                                          */
/*       = 1 -  ࠢ                                            */
/*------------------------------------------------------------------------*/
xCheckIpAddrByte: procedure
   pByte = arg(1)

   if DataType( pByte, 'W' ) then do
      if (pByte>=0) & (pByte<=255) then do
         return 1
      end
   end
   return 0
/*------------------------------------------------------------------------*/
/*  㭪樨 xCheckIpAddrByte()                                       */
/**************************************************************************/



/**************************************************************************/
/* xGetHexMask()                                                          */
/*========================================================================*/
/* ᠭ: ந   hex-ଥ                                  */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetHexMask( pMask )                                           */
/*                                                                        */
/* ࠬ:                                                             */
/*    pMask - ᫮ ⮢  ᪥                                  */
/*                                                                        */
/* :                                                               */
/*    rc - ᪠   hex-ଥ                                      */
/*------------------------------------------------------------------------*/
xGetHexMask: procedure
   pMask = arg(1)

   rc = b2x( Copies( '1', pMask )||Copies( '0', 32 - pMask ) )
   return rc
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetHexMask()                                            */
/**************************************************************************/



/**************************************************************************/
/* xCalcMask()                                                            */
/*========================================================================*/
/* ᠭ:  ࠢ                                   */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xCalcMask( pMask )                                             */
/*                                                                        */
/* ࠬ:                                                             */
/*    pMask - ᪠                                                */
/*                                                                        */
/* :                                                               */
/*    rc - ⠭ ᪠                                     */
/*------------------------------------------------------------------------*/
xCalcMask: procedure
   pMask = arg(1)

   xPos = xGetMaskSize( pMask )
   xHex = b2x( Copies( '1', xPos )||Copies( '0', 32 - xPos ) )
   xDot = xHexToDot( xHex )

   return xDot
/*------------------------------------------------------------------------*/
/*  㭪樨 xCalcMask()                                              */
/**************************************************************************/



/**************************************************************************/
/* xGetMaskSize()                                                         */
/*========================================================================*/
/* ᠭ:  ࠧ ᪨                                      */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetMaskSize( pMask )                                          */
/*                                                                        */
/* ࠬ:                                                             */
/*    pMask - ᪠                                                */
/*                                                                        */
/* :                                                               */
/*    rc - ࠧ ᪨                                            */
/*------------------------------------------------------------------------*/
xGetMaskSize: procedure
   pMask = arg(1)

   xHex = xDotToHex( pMask )
   xPos = Pos( '0', x2b( xHex ) ) - 1
   if xPos < 0 then do
      xPos = 32
   end

   return xPos
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetMaskSize()                                           */
/**************************************************************************/



/**************************************************************************/
/* xCheckMaskSize()                                                       */
/*========================================================================*/
/* ᠭ: ஢ઠ ࠢ쭮 ࠧ ᪨                          */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xCheckMaskSize( pSize )                                        */
/*                                                                        */
/* ࠬ:                                                             */
/*    pSize - ᫮ ⮢  ᪥                                  */
/*                                                                        */
/* :                                                               */
/*    rc = 0 - ᪠ ࠢ쭠                                         */
/*       = 1 - ᪠ ࠢ쭠                                           */
/*------------------------------------------------------------------------*/
xCheckMaskSize: procedure
   pSize = arg(1)

   if DataType( pSize, 'W' ) then do
      if (pSize>=0) & (pSize<=32) then do
         return 1
      end
   end
   return 0
/*------------------------------------------------------------------------*/
/*  㭪樨 xCheckMaskSize()                                         */
/**************************************************************************/



/**************************************************************************/
/* xGetAnsiValue()                                                        */
/*========================================================================*/
/* ᠭ: 樠 ANSI ᫥⥫쭮⥩  뢮  ࠭   */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xGetAnsiValue()                                                */
/*                                                                        */
/* ࠬ:                                                             */
/*                                                                     */
/*                                                                        */
/* :                                                               */
/*    rc = 0 - 樠஢                                           */
/*------------------------------------------------------------------------*/
xGetAnsiValue: procedure expose mr.
   xEsc=x2c('1B')

/**************************************************************************/
/*   ()                                                  */
/**************************************************************************/
   mr.n.K = xEsc||'[0;30m'      /* Black   -          */
   mr.n.R = xEsc||'[0;31m'      /* Red     -         */
   mr.n.G = xEsc||'[0;32m'      /* Green   -         */
   mr.n.Y = xEsc||'[0;33m'      /* Yellow  -          */
   mr.n.B = xEsc||'[0;34m'      /* Blue    - ᨭ          */
   mr.n.M = xEsc||'[0;35m'      /* Magenta - ७      */
   mr.n.C = xEsc||'[0;36m'      /* Cyan    -       */
   mr.n.W = xEsc||'[0;37m'      /* White   -           */

/**************************************************************************/
/*   (ન)                                                    */
/**************************************************************************/
   mr.b.K = xEsc||'[1;30m'      /* Black   -          */
   mr.b.R = xEsc||'[1;31m'      /* Red     -         */
   mr.b.G = xEsc||'[1;32m'      /* Green   -         */
   mr.b.Y = xEsc||'[1;33m'      /* Yellow  -          */
   mr.b.B = xEsc||'[1;34m'      /* Blue    - ᨭ          */
   mr.b.M = xEsc||'[1;35m'      /* Magenta - ७      */
   mr.b.C = xEsc||'[1;36m'      /* Cyan    -       */
   mr.b.W = xEsc||'[1;37m'      /* White   -           */

/**************************************************************************/
/*  䮭                                                              */
/**************************************************************************/
   mr.g.K = xEsc||'[0;40m'      /* Black   -          */
   mr.g.R = xEsc||'[0;41m'      /* Red     -         */
   mr.g.G = xEsc||'[0;42m'      /* Green   -         */
   mr.g.Y = xEsc||'[0;43m'      /* Yellow  -          */
   mr.g.B = xEsc||'[0;44m'      /* Blue    - ᨭ          */
   mr.g.M = xEsc||'[0;45m'      /* Magenta - ७      */
   mr.g.C = xEsc||'[0;46m'      /* Cyan    -       */
   mr.g.W = xEsc||'[0;47m'      /* White   -           */

/**************************************************************************/
/* Windowed - ન 梥 䮭 (Full Screen - 栭)                    */
/**************************************************************************/
   mr.f.K = xEsc||'[5;40m'      /* Black   -          */
   mr.f.R = xEsc||'[5;41m'      /* Red     -         */
   mr.f.G = xEsc||'[5;42m'      /* Green   -         */
   mr.f.Y = xEsc||'[5;43m'      /* Yellow  -          */
   mr.f.B = xEsc||'[5;44m'      /* Blue    - ᨭ          */
   mr.f.M = xEsc||'[5;45m'      /* Magenta - ७      */
   mr.f.C = xEsc||'[5;46m'      /* Cyan    -       */
   mr.f.W = xEsc||'[5;47m'      /* White   -           */

/**************************************************************************/
/* ਡ                                                               */
/**************************************************************************/
   mr.a.O = xEsc||'[0m'         /* Off        -  몫祭             */
   mr.a.B = xEsc||'[1m'         /* Bold       - 襭 મ         */
   mr.a.N = xEsc||'[2m'         /* Normal     - 筠 મ           */
   mr.a.L = xEsc||'[5m'         /* Blind      - 栭(FS) ન 䮭(W) */
   mr.a.I = xEsc||'[7m'         /* Inverse    -                   */
   mr.a.V = xEsc||'[8m'         /* Invisible  -                  */

/**************************************************************************/
/*                                                                 */
/**************************************************************************/
   mr.c.Cs = xEsc||'[2J'        /* ⪠ ᥣ ࠭         */
   mr.c.Cl = xEsc||'[0K'        /* ⪠ ப      */
   mr.c.Mu = xEsc||'[1A'        /*   1 ப      */
   mr.c.Md = xEsc||'[1B'        /*   1 ப       */
   mr.c.Mr = xEsc||'[1C'        /*   1 ⮫ ࠢ   */
   mr.c.Ml = xEsc||'[1D'        /*   1 ⮫     */
   mr.c.Ps = xEsc||'[1s'        /*       */
   mr.c.Pr = xEsc||'[1u'        /* ⠭   */

   mr.c.Reset = mr.a.O||mr.g.K||mr.n.W
   return 0
/*------------------------------------------------------------------------*/
/*  㭪樨 xGetAnsiValue()                                          */
/**************************************************************************/



/**************************************************************************/
/* xHowUse()                                                              */
/*========================================================================*/
/* ᠭ: 뢮 ᠭ ᨭ⠪  ப  室           */
/*                                                                        */
/* ⠪:                                                             */
/*    rc = xHowUse()                                                      */
/*                                                                        */
/* ࠬ:                                                          */
/*                                                                        */
/* :                                                            */
/*                                                                        */
/*------------------------------------------------------------------------*/
xHowUse: procedure
   say ''
   say 'Usage: rxCalcNet subnet/mask_size'
   say '       rxCalcNet subnet mask'
   say '       rxCalcNet address1-address2'
   say ''
   say ' i.e.: rxCalcNet 192.168.2.0/24'
   say '       rxCalcNet 192.168.2.0 255.255.255.0'
   say '       rxCalcNet 192.168.2.0-192.168.2.255'
   exit 1;
/*------------------------------------------------------------------------*/
/*  㭪樨 xHowUse()                                                */
/**************************************************************************/



/*------------------------------------------------------------------------*/
/*  䠩 rxCalcNet.cmd                                              */
/**************************************************************************/
